<?php
/*
Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
	// infos de configuration 
	require_once("utils.php");

	// constantes
	$filename    = "dhcpd.conf";
	$header      = "# dhcpd.conf\n#\n# Authors : Rtp & Duck\n#\n# Genere a partir du script dhcp.php a l'aide du schema LDAP courant\n#\n#\n#\n\n\nauthoritative;\n\n\n";
	$eol         = ";\n";

function comm_option($fp,$ini) {
	global $eol;

	fwrite($fp,"# all networks common options\n");
	fwrite($fp,"option subnet-mask ".$ini["subnet"]["netmask"].$eol);
	fwrite($fp,"default-lease-time ".$ini["dhcpd_header"]["default_lease_time"].$eol);
	fwrite($fp,"max-lease-time     ".$ini["dhcpd_header"]["max_lease_time"].$eol);
	
	$subnets = explode(" ",$ini["subnet"]["subnet"]);
	
	for($i=0;$i<count($subnets);$i++) {
		fwrite($fp,"\nsubnet ".$subnets[$i]." netmask ".$ini["subnet"]["netmask"]." {\n");

		$range_dynamic=explode(" ",$ini["subnet"]["range_dynamic"]);

		fwrite($fp,"\trange ".get_subnet_from_ip($subnets[$i]).".".$range_dynamic[0]." ".get_subnet_from_ip($subnets[$i]).".".$range_dynamic[1].$eol);

		fwrite($fp,"\toption broadcast-address ".get_subnet_from_ip($subnets[$i]).".255".$eol);
		fwrite($fp,"}\n");
	}

}
function write_services($fp,$SrvMgr,$dn) {
	global $eol;
	$OptionNames=array(
	"dns"=>"domain-name-servers",
	"wins"=>"netbios-name-servers",
	"ntp"=>"ntp-servers",
	"irc"=>"irc-server",
	"pop"=>"pop-server",
	"smtp"=>"smtp-server",
	"www"=>"www-server"
	);
		
	$r =& $SrvMgr->get_list(array("primaryservername","servername"));
	$nb = $r->get_result('count');
        $SrvMgr->sort_result_by_attr('cn');
        for ($i=0;$i<$nb;$i++) {
		$r =& $SrvMgr->select_result($i);
		$cn = $r->get_result('cn');
		if (in_array($cn,array_flip($OptionNames))) {
			$server = $r->get_result('primaryservername');
			$result = $r->get_result('servername');
			fwrite($fp,"\toption ".$OptionNames[$cn]." ".$server.".".$dn);
			if ($result) {
				foreach ($result as $name) {
					fwrite($fp,",".$name.".".$dn);
				}
			}
			fwrite($fp,$eol);
			if (!strcasecmp($cn,"wins")) {
				fwrite($fp,"\toption netbios-dd-server ".$server.".".$dn.$eol);
				fwrite($fp,"\toption netbios-node-type 8".$eol);
			}
		}
	}
}
function write_host($fp,$HostName,$HostMac,$HostAdd) {
	global $eol;
	
	fwrite($fp,"\thost ".$HostName." {\n");
	fwrite($fp,"\t\thardware ethernet ".$HostMac.$eol);
	fwrite($fp,"\t\tfixed-address ".$HostAdd.$eol);
	fwrite($fp,"\t}\n");
}
function write_fixed_option($fp,$subnet,$dn) {
	global $eol;
	
	fwrite($fp,"\toption broadcast-address ".$subnet.".255".$eol);
	fwrite($fp,"\toption domain-name \"".$dn."\"".$eol);
	fwrite($fp,"\tuse-host-decl-names on".$eol);
}
function write_group($fp,$GroupName,$Router,$Subnet,$Dn,$HostNames,$HostMacs,$HostAdds,$HostCount,$SrvMgr) {
	global $eol;
	
	fwrite($fp,"\n\n# Group ".$GroupName."\n");
	fwrite($fp,"group {\n");
	write_fixed_option($fp,$Subnet,$Dn);
	write_services($fp,$SrvMgr,$Dn);
	$tmp=$Subnet.".0";

	if ($Router != "") {
		fwrite($fp,"\n\toption routers ".$Router.$eol."\n");
	} 
	else {
		fwrite($fp,"\n\n");
	}

	for($i=0;$i<$HostCount;$i++) {
		write_host($fp,$HostNames[$i],$HostMacs[$i],$HostAdds[$i]);
	}
	fwrite($fp,"}\n\n");
}
function write_groups($fp,$ini,$AdslMgr,$HostMgr,$SrvMgr,$ds,$subnet) {

	$dn = ds2dn($ds);
	
	fwrite($fp,"\n########################\n");
	fwrite($fp,"# ".$subnet.".0        \n");
	fwrite($fp,"########################\n");
	
	$RouterCount     = 0;
	$CommonHostCount = 0;
	$MarkedHostCount = 0;
	$MarkedHost      = array();

	$r =& $AdslMgr->get_list(array("servername","hostname"));
	$AdslGroupCount = $r->get_result('count');
	$AdslMgr->sort_result_by_attr('cn');
	for($i=0;$i<$AdslGroupCount;$i++) {
		$AdslHostCount   = 0;
		unset($AdslHostName);
		unset($AdslHostAdd);
		unset($AdslHostName);
		unset($router);
		$AdslMgrRes =& $AdslMgr->select_result($i);
		
		/* Get this adslgroup's name */
		$AdslGroupName = $AdslMgrRes->get_result('cn');
		
		/* Determine the router's name (and mac, addresse if needed) for this adslgroup */
		$AdslServer = $AdslMgrRes->get_result('servername');
		$r =& $HostMgr->find($AdslServer);
		$HostMgrRes =& $HostMgr->select_result(0);
		$IpList=$HostMgrRes->get_result('iphostnumber');
		foreach($IpList as $Ip) {
			if (ip_belong_to_subnet($Ip,$subnet)) {
				$router=$AdslServer.".".$dn;
				$r =& $HostMgr->get_host_type();
				if ($r->get_result('host_type') == LMS_HTYPE_COMMON) {
					$cn=$HostMgrRes->get_result('cn');
					$Mac=$HostMgrRes->get_result('macaddress');
					$PersonalAdslRouterName[$RouterCount]= $cn;
					$PersonalAdslRouterAdd[$RouterCount]= $cn.".".$dn;
					$PersonalAdslRouterMac[$RouterCount++]=$Mac[0];
					$MarkedHostName[$MarkedHostCount++]=$cn;
				}
			}
		}
		if ($router == "") {
			$tmp=$subnet.".0";
	                $router=$ini["routers"][$tmp];
		}

		/* Fetch all host in this adsl group */
		$AdslHosts=$AdslMgrRes->get_result('hostname');
		foreach($AdslHosts as $Host) {
			$r =& $HostMgr->get_list(LMS_HTYPE_COMMON,
				array("iphostnumber","macaddress","ismobilecomputer"),
				'cn='.$Host);
			$r =& $HostMgr->select_result(0);
			$Ip=$r->get_result('iphostnumber');
			$Mac=$r->get_result('macaddress');
			$cn=$r->get_result('cn');
			if (strcasecmp($cn,$AdslServer) != 0) {
				if (ip_belong_to_subnet($Ip[0],$subnet)) {
					$AdslHostName[$AdslHostCount]=$cn;
					$AdslHostAdd[$AdslHostCount]=$cn.".".$dn;
					$AdslHostMac[$AdslHostCount++]=$Mac[0];
					$MarkedHostName[$MarkedHostCount++]=$cn;
				} else if ($r->get_result('ismobilecomputer')) {
					$MarkedHostName[$MarkedHostCount++]=$cn;
					$cn=$cn."-".get_subnetnbr($subnet);
					$AdslHostName[$AdslHostCount]=$cn;
					$AdslHostAdd[$AdslHostCount]=$AdslHostName[$AdslHostCount].".".$dn;
					$AdslHostMac[$AdslHostCount++]=$Mac[0];
				}
			}
		}

		/* Write infos in the file */
		if ($AdslHostCount) {
			write_group($fp,
				$AdslGroupName,
				$router,
				$subnet,
				$dn,
				$AdslHostName,
				$AdslHostMac,
				$AdslHostAdd,
				$AdslHostCount,
				$SrvMgr
				);
		}
	}

	/* Find non marked host */
	$r =& $HostMgr->get_list(LMS_HTYPE_COMMON,array("iphostnumber","macaddress","ismobilecomputer"));
	$Count = $r->get_result('count');
	$HostMgr->sort_result_by_attr('cn');
	for($i=0;$i<$Count;$i++) {
		$r =& $HostMgr->select_result($i);
		$cn=$r->get_result('cn');
		$mac=$r->get_result('macaddress');
		$ip=$r->get_result('iphostnumber');
		if ( ($r->get_result('ismobilecomputer') || ip_belong_to_subnet($ip[0],$subnet)) && !in_array($cn,$MarkedHostName)) {
			if ($r->get_result('ismobilecomputer')) {
				$CommonHostName[$CommonHostCount]=$cn."-".get_subnetnbr($subnet);
			} 
			else {
				$CommonHostName[$CommonHostCount]=$cn;
			}
			$CommonHostAdd[$CommonHostCount]=$CommonHostName[$CommonHostCount].".".$dn;
			$CommonHostMac[$CommonHostCount++]=$mac[0];
		}
	}
	
	/* Write not yet saved infos */
	if ($CommonHostCount) {
		$tmp=$subnet.".0";
		write_group($fp,
			"Common Hosts",
			$ini["routers"][$tmp],
			$subnet,
			$dn,
			$CommonHostName,
			$CommonHostMac,
			$CommonHostAdd,
			$CommonHostCount,
			$SrvMgr
			);
	}
	if ($RouterCount) {
		write_group($fp,
			"Personal Adsl Routers",
			"",
			$subnet,
			$dn,
			$PersonalAdslRouterName,
			$PersonalAdslRouterMac,
			$PersonalAdslRouterAdd,
			$RouterCount,
			$SrvMgr
			);
	}

}
function write_conf_file($ini,$AdslMgr,$HostMgr,$SrvMgr,$config) {	
	global $filename;
	global $eol;
	global $header;
	
	// ouverture du fichier de sortie
	$fp=openconf($filename.".tmp",$ini["outputdirs"]["dhcp"]);

	// ecriture du fichier
	fwrite($fp,$header);
	fwrite($fp,"ddns-update-style ".$ini["dhcpd_header"]["ddns_update_style"].$eol."\n");

	// options communes a tous les reseaux
	comm_option($fp,$ini);

	$subnets=explode(" ",$ini["subnet"]["subnet"]);
	
	for($i=0;$i<count($subnets);$i++) {
		write_groups($fp,$ini,$AdslMgr,$HostMgr,$SrvMgr,$config[base],get_subnet_from_ip($subnets[$i]));
	}

	// fermeture du fichier
	fclose($fp);
	
	// verification des fichiers afin de savoir si on doit faire une M.A.J.
	$path=$ini["outputdirs"]["dhcp"];
	if (is_maj($filename.".tmp",$path)) {
		if (strcmp(substr($path,-1),"/") != 0 ) {
			$path=$path."/";
		}
		copy($path.$filename.".tmp",$path.$filename);
	}
	else {
		del_old_conf($filename.".tmp",$ini["outputdirs"]["dhcp"]);
	}

}

/************************************************************************************/
/* 'MAIN'                                                                           */
/*                                                                                  */
/************************************************************************************/
	
	// ouverture du fichier de parametrage
	$ini = parse_ini_file($ini_file,TRUE);


	if ($ini["general"]["die"]) {
		exit(2);
	}
	
	$langmgr =& new DftkDaLanguageManager();
	$resultmgr =& new DftkDaTraceManager($langmgr);
	
	$con =& new DftkLdapConnection($resultmgr);
	$con->set_wrapping_parameter($config[base], "ou=Users", "ou=CommonUsers", "ou=AdminUsers", "ou=ServiceUsers");
	
	$r =& $con->connect($config[server], true);
	
	if ($r->has_error()) {
		print($r->get_debug_msg(true));
		exit(1);
	}
	
	$r =& $con->bind( $config[login],$config[passwd]);
	if ($r->has_error()) {
		print($r->get_debug_msg(true));
		exit(1);
	}
	
	
	$AdslMgr =& new LmsAdslGroupManager ($resultmgr, $con);
	$HostMgr =& new LmsHostManager      ($resultmgr, $con);
	$SrvMgr  =& new LmsServiceManager   ($resultmgr, $con);

	write_conf_file($ini,$AdslMgr,$HostMgr,$SrvMgr,$config);

	// fermeture de la connection ldap
	$con->disconnect();

	if ($ini["general"]["gen_only"]) {
		exit(3);
	}

?>
